# i-bem.js: руководство пользователя

## i-bem.js: JavaScript-фреймворк для БЭМ

`i-bem.js` — специализированный JavaScript-фреймворк для веб-разработки в рамках [БЭМ-методологии](https://ru.bem.info/method/).

`i-bem.js` позволяет:

 * разрабатывать веб-интерфейс в терминах блоков, элементов, модификаторов;
 * описывать логику работы блока в декларативном стиле — как набор состояний;
 * легко интегрировать JavaScript-код с BEMHTML- или BH-шаблонами и CSS в стиле БЭМ;
 * гибко переопределять поведение библиотечных блоков.

`i-bem.js` не предназначен для замены фреймворка общего назначения, подобного jQuery.

**Краткий обзор содержания документа**:

* [Общие сведения][common] о фреймворке: связь с предметной областью БЭМ, краткое описание модульной структуры
фреймворка, шаблонного проекта и инструментов для сборки кода,
написанного с использованием `i-bem.js`.
* [Привязка JS-экземпляров к HTML][html] — разметка JS-блоков в HTML-коде страницы, варианты соотношения HTML-элементов и JS-экземпляров.
* [Декларация][decl] — синтаксис описания класса блока и элемента.
* [Передача параметров][params] — передача параметров экземпляру блока и элемента, получение доступа к параметрам из экземпляра.
* [Работа с DOM-деревом][dom] — API для работы с DOM-узлами блоков и элементов.
* [Состояния][states] — модификаторы, триггеры на изменение модификаторов.
* [Коллекции][collections] — работа с несколькими экземплярами блоков или элементов.
* [События][events] — событийная модель `i-bem.js`: DOM- и БЭМ-события.
* [Инициализация][init] — инициализация экземпляров блоков и элементов.
* [Взаимодействие блоков][interact] — обращение из экземпляра блока или элемента к другим экземплярам и классам.
* [Контекст][context] —  собственные и статические свойства блока и элемента. Статические свойства `i-bem-dom`.
* [Что дальше?][extras] — ссылки на документацию и дополнительные материалы.

[common]: ./i-bem-js-common.ru.md

[html]: ./i-bem-js-html-binding.ru.md

[decl]: ./i-bem-js-decl.ru.md

[dom]: ./i-bem-js-dom.ru.md

[context]: ./i-bem-js-context.ru.md

[states]: ./i-bem-js-states.ru.md

[events]: ./i-bem-js-events.ru.md

[params]: ./i-bem-js-params.ru.md

[init]: ./i-bem-js-init.ru.md

[init-lazy]: ./i-bem-js-init.ru.md#init-lazy

[collections]: ./i-bem-js-collections.ru.md

[interact]: ./i-bem-js-interact.ru.md

[extras]: ./i-bem-js-extras.ru.md
